/*helper function to clear unsubmitted form changes.
Assumption: custom attributes are set when populating the form
see: gateway/dhcpd for example
*/
function clearFormUpdates(formId,submitButtonId,cancelButtonId,applyButtonId)
{
if(formId!=null)
{
var objForm = document.getElementById(formId);
if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if (formElements[i].type == 'submit')
{
continue;
}
if (formElements[i].name == 'iehack')
{
continue;
}
if (formElements[i].type == 'checkbox' || formElements[i].type == 'radio')
{
var oldState=formElements[i].getAttribute('org_state');
formElements[i].checked=((oldState=='true')?true:false);
}
if (formElements[i].type == 'text')
{
formElements[i].value=formElements[i].getAttribute('org_value');
}
if (formElements[i].type == 'select-one')
{
for(var opt=0;opt<formElements[i].options.length;opt++)
{
if(formElements[i].options[opt].text==formElements[i].getAttribute('org_value'))
{
formElements[i].selectedIndex=opt;
break;
}
}
}
}
}
}
}
var d = document.getElementById('results');
if(d)
{
/*clear messages*/
d.innerHTML="";
d.style.display = 'none';
}
updateButtonVisibilities(formId,submitButtonId,cancelButtonId,applyButtonId);
return;
}
/*helper function to apply submitted form changes to custom attributes.
Assumption: custom attributes are set when populating the form
see: gateway/dhcpd for example
*/
function submitFormUpdates(formId,submitButtonId,cancelButtonId,applyButtonId)
{
if(formId!=null)
{
var objForm = document.getElementById(formId);
if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if (formElements[i].type == 'submit')
{
continue;
}
if (formElements[i].name == 'iehack')
{
continue;
}
if (formElements[i].type == 'checkbox' || formElements[i].type == 'radio')
{
var newState=((formElements[i].checked)?'true':'false');
formElements[i].setAttribute('org_state',newState);
}
if (formElements[i].type == 'text')
{
formElements[i].setAttribute('org_value',formElements[i].value);
}
if (formElements[i].type == 'select-one' && formElements[i].options.length)
{
formElements[i].setAttribute('org_value',formElements[i].options[formElements[i].selectedIndex].text);
}
}
}
}
}
updateButtonVisibilities(formId,submitButtonId,cancelButtonId,applyButtonId);
return;
}
/*helper function to determine form changes by comparing custom attribute value to current element value.
Assumption: custom attributes are set when populating the form
see: gateway/dhcpd for example
*/
function updateButtonVisibilities(formId,submitButtonId,cancelButtonId,applyButtonId)
{
var bApplyButtonVisible=false;
var bSubmitButtonVisible=false;
var bCancelButtonVisible=false;
if(formId!=null)
{
var objForm = document.getElementById(formId);
if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if (formElements[i].type == 'submit')
{
continue;
}
if (formElements[i].name == 'iehack')
{
continue;
}
if (formElements[i].type == 'checkbox' || formElements[i].type == 'radio')
{
var oldState=formElements[i].getAttribute('org_state');
var newState=formElements[i].checked;
if(newState.toString()!=oldState)
{
bApplyButtonVisible=true;
bSubmitButtonVisible=true;
bCancelButtonVisible=true;
}
}
if (formElements[i].type == 'text')
{
if(formElements[i].getAttribute('org_value')!=formElements[i].value)
{
bApplyButtonVisible=true;
bSubmitButtonVisible=true;
bCancelButtonVisible=true;
}
}
if (formElements[i].type == 'select-one' && formElements[i].options.length)
{
if(formElements[i].getAttribute('org_value')!=formElements[i].options[formElements[i].selectedIndex].text)
{
bApplyButtonVisible=true;
bSubmitButtonVisible=true;
bCancelButtonVisible=true;
}
}
}
}
}
}

if(document.getElementById(submitButtonId))
{
document.getElementById(submitButtonId).disabled=false;
document.getElementById(submitButtonId).style.visibility=bSubmitButtonVisible?"visible":"hidden";
document.getElementById(submitButtonId).style.display=bSubmitButtonVisible?"":"none";
}
if(document.getElementById(cancelButtonId))
{
document.getElementById(cancelButtonId).disabled=false;
document.getElementById(cancelButtonId).style.visibility=bCancelButtonVisible?"visible":"hidden";
document.getElementById(cancelButtonId).style.display=bSubmitButtonVisible?"":"none";
}
if(document.getElementById(applyButtonId))
{
document.getElementById(applyButtonId).disabled=false;
document.getElementById(applyButtonId).style.visibility=bApplyButtonVisible?"visible":"hidden";
document.getElementById(applyButtonId).style.display=bSubmitButtonVisible?"":"none";
}
}

function GetRealTextNode(node)
{
if(node.hasChildNodes() && node.firstChild.nodeType != 3)
{
return node.firstChild;
}
else if(node.hasChildNodes() && node.childNodes[1].nodeType == 1)
{
return node.childNodes[1];
}
else if(node.hasChildNodes() && node.firstChild.nodeType == 1)
{
return node.firstChild;
}
return null;
}

function GetHiddenFrameOutput(hframe)
{
var i;
var j;
var target;
var data;
var nodes = window.frames[hframe].document.getElementsByTagName('xml');
for(i = 0; i < nodes.length; ++i)
{
var node = GetRealTextNode(nodes[i]);
if(node)
{
target = null;
data = null;
for(j = 0; j < node.childNodes.length ; ++j)
{
if(
node.childNodes[j].nodeName.toLowerCase() == "target" &&
node.childNodes[j].firstChild
)
{
target = node.childNodes[j].firstChild.nodeValue;
}
else if(node.childNodes[j].nodeName.toLowerCase() == "data")
{
data = node.childNodes[j];
}
}
if(target && data)
{
eval(target + "(data);");
}
}
}
}

confirmPostProcedure = "";

function PrintMsg(xml, id)
{
var d = document.getElementById(id);
if(d)
{
fadeObj = new fx.Opacity(id, {duration: 800});
fadeObj.hide();
var isStr = true;
if(xml.firstChild)
{
isStr = false;
}
if(
(xml.nodeType == 1 && ! xml.firstChild) || /* iframe xml parse empty */
(isStr && xml.length == 0) ||
(
! isStr &&
(! xml.firstChild || xml.firstChild.nodeValue == '')
)
)
{
/* Clear. */
d.innerHTML = '';
d.style.display = 'none'; /* Don't display (iehack) */
}
else
{
var r = d.innerHTML;
if(
(isStr && xml == 'br') ||
(! isStr && xml.firstChild.nodeValue == 'br')
)
{
/* Newline catch. */
r += "<br>";
}
else
{
/* Append. */
var msg = isStr ? xml : xml.firstChild.nodeValue;
var detectedReturnChar = (msg.charAt(msg.length - 1) == '\r')
if(detectedReturnChar)
{
msg = msg.substring(0, msg.length - 1);
}
{
/* Trim the last line if not terminated by <br/>. */
var lastBr = r.lastIndexOf("<br>");
var lastBrUpperCase = r.lastIndexOf("<BR>");
if(lastBrUpperCase >= 0)
{
lastBr = lastBrUpperCase;
}
if(lastBr >= 0)
{
if(lastBr < r.length - 4)
{
r = r.substring(0, lastBr + 4);
}
}
else
{
r = '';
}
}
if(msg.match(/^CONFIRM:/))
{
r += "<b>";
r += "<span class=\"errorLog\">";
r += msg;
r += " [<a ";
r += 'href="javascript:void(0)"';
r += 'onclick="';
r += "var confirms = GetDisplayValue('confirms');";
r += "SetDisplayValue('confirms', '' + confirms + '" + msg + "');";
r += confirmPostProcedure;
r += "return false;";
r += '"';
r += ">Okay</a>]";
r += " [<a ";
r += 'href="javascript:void(0)"';
r += 'onclick="';
r += "var curData = ajaxHistory.getCurrentData();";
r += "var curPage = ajaxHistory.getCurrentLocation();";
r += "return ajax_AddToHistory(curPage, curData);";
r += '"';
r += ">Cancel</a>]";
r += "</span>";
r += "</b>";
}
else
{
if(msg.match(/^ERROR:/))
{
r += "<span class=\"errorLog\">";
}
else if(msg.match(/^WARNING:/))
{
r += "<span class=\"warnLog\">";
}
else
{
r += "<span class=\"okLog\">";
}
r += msg + "</span>";
}
if(! detectedReturnChar)
{
r += "<br>";
}
}
d.innerHTML = r;
d.style.display = 'block';
}
fadeObj.toggle();
}
}

function PrintPostResults(xml)
{
PrintMsg(xml, 'results');
}

function GetXmlDataByZeroBasedIndex(node, tag, z)
{
var e = node.getElementsByTagName(tag);
if(e.length <= z)
{
return null;
}
else if(e[z].firstChild == null)
{
return "";
}
return e[z].firstChild.nodeValue;
}

function GetXmlData(node, tag)
{
return GetXmlDataByZeroBasedIndex(node, tag, 0);
}

function GetXmlBool(node, tag)
{
var d = GetXmlData(node, tag);
return (d && d == "1");
}

/*helper function to convert xml node to string*/
function XMLToString(oXML)
{
if(oXML==null)return "";
if (window.ActiveXObject)
{
return oXML.xml;
}
else
{
return (new XMLSerializer()).serializeToString(oXML);
}
}

function GetMsgAndDisplay(xml)
{
if(! xml || ! xml.hasChildNodes())
{
alert("ERROR: Unable to display message.");
}
else
{
var f = GetXmlData(xml, "f");
var c = GetXmlData(xml, "c");
var i = GetXmlData(xml, "i");
var msg = _msgs[c][i];
eval(f + "(msg);");
}
}

function GetMsgAndDisplayPrintf(xml)
{
if(! xml || ! xml.hasChildNodes())
{
alert("ERROR: Unable to display message.");
}
else
{
var f = GetXmlData(xml, "f");
var c = GetXmlData(xml, "c");
var i = GetXmlData(xml, "i");
var msg = _msgs[c][i];
var finalMsg = msg.slice(0); /* Copy the message. */
var args = xml.getElementsByTagName('arg');
for(var i = 0; i < args.length; i++)
{
finalMsg = decodeURIComponent(finalMsg);
finalMsg = finalMsg.replace(
/\{\}/,
args[i].firstChild ? args[i].firstChild.nodeValue : ""
);
}
eval(f + "(finalMsg);");
}
}

function MainStatusRender(xml)
{
IndexDisplayElement(document.getElementById('status_Index'));
document.getElementById('documentData').innerHTML = '';
document.getElementById('subnavData').innerHTML = '';
var d = document.getElementById('contentData');
d.innerHTML = '';
var r = '<h2>Device Status</h2>';
if(! xml || ! xml.hasChildNodes())
{
r += "No MIB data is available.";
}
else
{
r += "<table class=\"basicTable statusTable\">";
r += "<tr class=\"statusHeader\"><td colspan=\"3\"><b>Product Information</b></td></tr>";
r += "<tr><td><b>Product Type:</b></td><td colspan=\"2\">" + GetXmlData(xml, "pn") + "</td></tr>";
r += "<tr><td><b>Firmware Version:</b></td><td colspan=\"2\">" + GetXmlData(xml, "fv") + "</td></tr>";



r += "<tr><td><b>Build Date:</b></td><td colspan=\"2\">" + GetXmlData(xml, "fbd") + "</td></tr>";
r += "<tr><td><b>Serial Number:</b></td><td colspan=\"2\">" + GetXmlData(xml, "sn") + "</td></tr>";
r += "<tr><td><b>Uptime:</b></td><td colspan=\"2\">" + GetXmlData(xml, "up") + "</td></tr>";

r += "<tr><td><b>Current Date/Time:</b></td><td colspan=\"2\">" + GetXmlData(xml, "date") + "</td></tr>";





r += "<tr><td><b>Temperature:</b></td><td colspan=\"2\">" + GetXmlData(xml, "temperature") + "</td></tr>";

var configState=GetXmlData(xml, "pc");
var requiresReboot=GetXmlData(xml, "requiresReboot");
r += "<tr><td><b>Permanent Config:</b></td><td colspan=\"2\">" + configState;
if(configState=="Unsaved")
{
r += ".";
r += "&nbsp;&nbsp;";
r += "<a href=\"javascript:void(0)\" ";
r += "onclick=\"";
r += "ajax_AddToHistory(";
r += "'StatusPage',";
r += "[true, 'cfgsave=true']";
r += ");";
r += "return false;";
r += "\"";
r += ">";
r += "<b>[Save]</b>";
r += "</a>";
//r += "<br>";
//r += "<img width=\"18\" height=\"18\" src=\"/config/warning.gif\" />&nbsp;";
//r += "<span class=\"warnLog\">WARNING: Some configuration changes have not been written to Flash.</span>";
}
if(requiresReboot=="yes")
{
r += "<br>";
r += "<form id=\"frmReboot\" name=\"frmReboot\" method=\"post\" autocomplete=\"off\" action=\"/reboot\">";
r += "<span>Device must be rebooted to apply recent changes to configuration.</span>"
r += "<input name=\"reboot\" type=\"text\" style=\"display:none;\" value=\"Reboot\" />";
r += "&nbsp;&nbsp;";
r += "<a href=\"javascript:void(0)\" ";
r += "onclick=\"";
r += "if(confirm('Are you SURE you want to reboot the device?";
if(configState=="Unsaved")
{
r += "\\r\\nWARNING: Configuration changes not saved to Flash will be lost.";
}
r += "')){";
r += "document.forms['frmReboot'].submit();";
r += "}";
r += "return false;";
r += "\"";
r += ">";
r += "<b>[Reboot]</b>";
r += "</a>";
r += "</form>";
//r += "<br>";
//r += "<img width=\"18\" height=\"18\" src=\"/config/warning.gif\" />&nbsp;";
//r += "<span class=\"warnLog\">WARNING: Some configuration changes will be applied after a reboot.</span>";
}
r += "</td></tr>";




var numAlarms = GetXmlData(xml, "active_alarms");
if(numAlarms!=0)
{
r += "<tr class=\"statusHeader\"><td colspan=\"3\"><b>Alerts</b></td></tr>";
for(var alarm=0;alarm<numAlarms;alarm++)
{
var name=GetXmlData(xml, "alarm_name_"+alarm);
var duration=GetXmlData(xml, "alarm_duration_"+alarm);
r += "<tr class=\"statusHeader2\"><td colspan='3'>Alarm (" + name + ")</td></tr>";
r += "<tr><td><b>Duration:</b></td><td colspan=\"2\">" + duration + "</td></tr>";
}
}

r += "<tr class=\"statusHeader\"><td colspan=\"3\"><b>Network Settings</b></td></tr>";
r += "<tr class=\"statusHeader2\"><td colspan=\"3\"><b>Name servers</b></td></tr>";
r += "<tr><td><b>Primary DNS:</b></td><td colspan=\"2\">" + GetXmlData(xml, "pdns") + "</td></tr>"
r += "<tr><td><b>Secondary DNS:</b></td><td colspan=\"2\">" + GetXmlData(xml, "sdns")+ "</td></tr>"
var numInterfaces = GetXmlData(xml, "numInterfaces");
for(var interface = 0; interface < numInterfaces; ++interface)
{
r += "<tr class=\"statusHeader2\"><td colspan=\"3\"><b>Interface ("+GetXmlData(xml, "intfc"+interface) + ")</b></td></tr>";
var interfaceState=GetXmlData(xml, "intfc_state"+interface);
if(interfaceState=="Enabled")
{
if(GetXmlData(xml, "link"+interface))
{
if (GetXmlData(xml, "intfc"+interface).indexOf("wwan") != -1)
{

r += "<tr><td><b>HSPA+ Status:</b></td><td colspan=\"2\">";



}
else
r += "<tr><td><b>Link:</b></td><td colspan=\"2\">";

r += GetXmlData(xml, "link"+interface) + "</td></tr>";
}
else r += "<tr><td><b>State:</b></td><td colspan=\"2\">" + interfaceState + "</td></tr>";
if(GetXmlData(xml, "mac"+interface))r += "<tr><td><b>MAC Address:</b></td><td colspan=\"2\">" + GetXmlData(xml, "mac"+interface) + "</td></tr>";
if(GetXmlData(xml, "host"+interface))r += "<tr><td><b>Hostname:</b></td><td colspan=\"2\">" + GetXmlData(xml, "host"+interface) + "</td></tr>";
if(GetXmlData(xml, "ip"+interface))r += "<tr><td><b>IP Address:</b></td><td colspan=\"2\">" + GetXmlData(xml, "ip"+interface) + "</td></tr>";
if(GetXmlData(xml, "rtr"+interface))r += "<tr><td><b>Default Gateway:</b></td><td colspan=\"2\">" + GetXmlData(xml, "rtr"+interface) + "</td></tr>";
if(GetXmlData(xml, "dom"+interface))r += "<tr><td><b>Domain:</b></td><td colspan=\"2\">" + GetXmlData(xml, "dom"+interface) + "</td></tr>";

if(GetXmlData(xml, "mtu"+interface))r += "<tr><td><b>MTU:</b></td><td colspan=\"2\">" + GetXmlData(xml, "mtu"+interface) + "</td></tr>";




}
else
{
r += "<tr><td><b>State:</b></td><td colspan=\"2\">" + interfaceState + "</td></tr>";
}
}
var numSerialPorts = GetXmlData(xml, "numSerialPorts");
if(numSerialPorts > 0)
{
r += "<tr class=\"statusHeader\">";
r += "<td colspan=\"3\"><b>Line Settings</b></td>";
r += "</tr>";
}
for(var line = 1; line <= numSerialPorts; ++line)
{
var name = GetXmlData(xml, "line" + line + "name");
r += "<tr>";
r += "<td><b>";
r += (
name.length > 0 ? name :
"Line " + line
);
r += ":</b></td>";
r += "<td colspan=\"2\">";
r += GetXmlData(xml, "line" + line + "set");
r += "</td>";
r += "</tr>";
}
r += "<tr class=\"statusHeader\">";
r += "<td><b>Tunneling</b></td>";
r += "<td><b>Connect<br>Mode</b></td>";
r += "<td><b>Accept<br>Mode</b></td>";
r += "</tr>"
var numTunnelPorts = GetXmlData(xml, "numTunnelPorts");
for(var line = 1; line <= numTunnelPorts; ++line)
{
r += "<tr>";
r += "<td><b>Tunnel " + line + ":" + "</b></td>";
r += "<td>" + GetXmlData(xml, "tun" + line + "con") + "</td>";
r += "<td>" + GetXmlData(xml, "tun" + line + "acc") + "</td>";
r += "</tr>";
}
r += "</table>";
}
d.innerHTML = r;
}
function WebMgrLogoutEnable(xml)
{
var lc = document.getElementById("logoutContainer");
if (lc)
{
lc.style.display = "block";
}
}
function WebMgrLogoutDisable(xml)
{
var lc = document.getElementById("logoutContainer");
if (lc)
{
lc.style.display = "none";
}
}
function HighlightElementInTable(tableId, elementId)
{
var navTable = document.getElementById(tableId);
if(navTable != undefined){
var entries = navTable.getElementsByTagName("td");
for(var i = 0; i < entries.length; ++i)
{
entries[i].style.border = '1px solid #efefef';
}
var e = document.getElementById(elementId);
if(e != undefined){
e.style.border = '1px solid #999';
}
}
}
function SetNav(xml)
{
var n1 = GetXmlData(xml, 'n1');
var n2 = GetXmlData(xml, 'n2');
var n3 = GetXmlData(xml, 'n3');
if(n1 != undefined)
{
HighlightElementInTable("Nav1", n1);
}
if(n2 != undefined)
{
HighlightElementInTable("Nav2", n2);
}
if(n3 != undefined && n3 >= 0){
HighlightElementInTable(n2 + "_Nav", n2 + "_" + (1 + Number(n3)));
document.getElementById(n2 + '_OptNav').style.display = 'inline';
}
}
showIdPrevious = "";
function ShowId(id)
{
var d = document.getElementById(showIdPrevious);
if(d)
{
d.style.display = 'none';
}
showIdPrevious = id;
d = document.getElementById(id);
if(d)
{
d.style.display = 'block';
}
}
function replaceString(mainStr, searchStr, replaceStr)
{
var foundOffset = mainStr.indexOf(searchStr);
if(foundOffset == -1)
{
return mainStr;
}
else
{
var front = mainStr.substring(0,foundOffset);
var back = mainStr.substring(foundOffset+searchStr.length,mainStr.length);
return front + replaceStr + replaceString(back,searchStr,replaceStr);
}
}
function stringMatch(x, y)
{
var x1 = replaceString(x, "&gt;", ">");
var y1 = replaceString(y, "&gt;", ">");
return (x1 == y1);
}
//*****************************************************************************
// Provide a common means to display file system compacting in web displays
var fileSystemStatusXmlHttp;
var fileSystemStatusEnable = false;
var fileSystemStatusTimer = null;
function FileSystemMonitor(){
fileSystemStatusEnable = true;
fileSystemStatusTimer=setTimeout("PollFileSystemStatus()", 1000);
}
function FileSystemMonitorDisable()
{
fileSystemStatusEnable = false;
clearTimeout(fileSystemStatusTimer);
fileSystemStatusTimer=null;
}
function PollFileSystemStatus(){
fileSystemStatusXmlHttp = ajax.getRequestObject();
if(fileSystemStatusXmlHttp){
var url = "/file_system_status?" + Date();
fileSystemStatusXmlHttp.open("GET", url, true);
fileSystemStatusXmlHttp.onreadystatechange = FileSystemStatusCallback;
fileSystemStatusXmlHttp.send(null);
clearTimeout(fileSystemStatusTimer);
fileSystemStatusTimer=null;
if(fileSystemStatusEnable)
{
fileSystemStatusTimer=setTimeout("PollFileSystemStatus()", 2000);
}
}
}
function FileSystemStatusCallback(){
if(fileSystemStatusXmlHttp && fileSystemStatusEnable){
if(fileSystemStatusXmlHttp.readyState == 4){
if(fileSystemStatusXmlHttp.status == 200){
if(
fileSystemStatusXmlHttp.responseText &&
fileSystemStatusXmlHttp.responseText.length > 0
){
var text = "" + fileSystemStatusXmlHttp.responseText + '\r';
PrintMsg(text, "results");
}
}
}
}
}
function GetInputElementValue(ie)
{
if(ie.type=="select-one")
{
if(ie.selectedIndex >= 0 && ie.selectedIndex < ie.length)
{
return ie.options[ie.selectedIndex].value;
}
return "";
}
else if(ie.type=="checkbox")
{
return ie.checked ? "Enabled" : "Disabled";
}
else if(ie.type==undefined && ie.length>0 && ie[0].type=="radio")
{
for(var i=0; i<ie.length; ++i)
{
if(ie[i].checked)
{
return ie[i].value;
}
}
return "";
}
else
{
return ie.value;
}
}
function GetDisplayValue(name)
{
var ie = document.forms[0].elements[name];
if(! ie)
{
return "";
}
return GetInputElementValue(ie);
}
function SetDisplayValue(name, value)
{
var n = document.forms[0].elements[name];
if(n)
{
if(n.type=="select-one")
{
for(var i=0; i<n.length; ++i)
{
if(n.options[i].value==value)
{
n.selectedIndex=i;
break;
}
}
}
else if(n.type=="checkbox")
{
n.checked = value == "Enabled";
}
else if(n.type==undefined && n.length>0 && n[0].type=="radio")
{
for(var i=0; i<n.length; ++i)
{
n[i].checked = n[i].value==value ? true : false;
}
}
else
{
n.value = value;
}
}
}
function SetDisplayValueEx(frmName,name, value)
{
var reqForm=document.getElementById(frmName);
if(reqForm)
{
var n = reqForm.elements[name];
if(n)
{
if(n.type=="select-one")
{
for(var i=0; i<n.length; ++i)
{
if(n.options[i].value==value)
{
n.selectedIndex=i;
break;
}
}
}
else if(n.type=="checkbox")
{
n.checked = value == "Enabled";
}
else if(n.type==undefined && n.length>0 && n[0].type=="radio")
{
for(var i=0; i<n.length; ++i)
{
n[i].checked = n[i].value==value ? true : false;
}
}
else
{
n.value = value;
}
}
}
}
function GetDivValue(e)
{
return e.textContent == undefined ? e.innerText : e.textContent;
}
function GetDivValueById(id)
{
var e = document.getElementById(id);
return GetDivValue(e);
}
function SetDisplaySelection(name)
{
displayElementRootNames.push(name);
var cvalue = GetDivValueById("current_" + name);
var s = document.getElementById("status_" + name);
if(s)
{
var svalue = GetDivValue(s);
s.style.backgroundColor = (cvalue == svalue ? "" : "yellow");
}
SetDisplayValue("new_" + name, cvalue);
return cvalue;
}
function SetDisplaySelectionEx(frmName, name)
{
displayElementRootNames.push(name);
var cvalue = GetDivValueById("current_" + name);
var s = document.getElementById("status_" + name);
if(s)
{
var svalue = GetDivValue(s);
s.style.backgroundColor = (cvalue == svalue ? "" : "yellow");
}
SetDisplayValueEx(frmName,"new_" + name, cvalue);
return cvalue;
}
function SetSubmit(enable, xml)
{
SetButtonVisibilities(xml);
if(document.getElementById('apply_button'))
{
fadeInOutApply.clearTimer();
fadeInOutApply.custom(
fadeInOutApply.now,
IsApplyButtonForcedToBeVisible() || enable ? 1 : 0
);
}
if(document.getElementById('submit_button'))
{
fadeInOutSubmit.clearTimer();
fadeInOutSubmit.custom(
fadeInOutSubmit.now,
IsSubmitButtonForcedToBeVisible() || enable ? 1 : 0
);
}
if(document.getElementById('test_button'))
{
//Test Connection button is always available
fadeInOutTest.clearTimer();
fadeInOutTest.custom(
fadeInOutTest.now,
true/*IsSubmitButtonForcedToBeVisible()*/ || enable ? 1 : 0
);
}
var rb = document.getElementById('reassert_button');
if(rb)
{
rb.style.backgroundColor = "yellow";
var displayReasert = false;
if(! IsSubmitButtonForcedToBeVisible() && ! enable)
{
for(var i = 0; i < displayElementRootNames.length; ++i)
{
var name = displayElementRootNames[i];
var c = document.getElementById("current_"+name);
var s = document.getElementById("status_"+name);
if(c && s && GetDivValue(c) != GetDivValue(s))
{
displayReasert = true;
break;
}
}
}
fadeInOutReassert.clearTimer();
fadeInOutReassert.custom(
fadeInOutReassert.now,
displayReasert ? 1 : 0
);
}
}
function Update(optElement)
{
if(optElement)
{
if(
optElement.value == "<None>" ||
optElement.value == "<Configured>" ||
optElement.value == "<Random>" ||
optElement.value == "<Default>"
)
{
optElement.select();
}
}
var somethingChanged = false;
for(var i = 0; i < displayElementRootNames.length; ++i)
{
var name = displayElementRootNames[i];
var cvalue = GetDivValueById("current_" + name);
var ie = document.forms[0].elements["new_" + name];
if(ie)
{
var nvalue = GetInputElementValue(ie);
if(cvalue != nvalue)
{
somethingChanged = true;
break;
}
}
else
{
alert("No element named new_" + name);
}
}
SetSubmit(somethingChanged);
}
//*****************************************************************************
// Support "sticky" tabs on the index display
var PreviousIndexDisplayElement;
function IndexDisplayElement(e)
{
if(PreviousIndexDisplayElement == undefined)
{
PreviousIndexDisplayElement = document.getElementById("status_Index");
}
PreviousIndexDisplayElement.style.backgroundColor = '#ff8000';
PreviousIndexDisplayElement = e;
e.style.backgroundColor = '#999';
}
function IndexIdChange(xml)
{
var id = GetXmlData(xml, "id");
if(id)
{
IndexDisplayElement(document.getElementById(id));
}
}
function isPhoneNumber(number)
{
var i,j,strTemp;
strTemp="0123456789-()# +";
for (i=0;i<number.length;i++){
j=strTemp.indexOf(number.charAt(i));
if (j==-1){
return false;
}
}
return true;
}
function isEmailAddress(addr)
{
var i = addr.length;
var temp = addr.indexOf('@');
var tempd = addr.indexOf('.');
if(temp>1){
if(i-temp > 3){
if(i-tempd>0){
return true;
}
}
}
return false;
}
/**
prefix : number item prefix
start: start number id
ennd: last number id
prompt message format: message + current id + message2
*/
function CheckNumbers(prefix,start,end,message,message2)
{
var i = start;
for(i=start;i<=end;i++){
var v = GetDisplayValue(prefix + i);
if(v != ""){
if(isPhoneNumber(v) == false){
alert(message + i + message2);
return false;
}
}
}
return true;
}
function CheckEmails(prefix,start,end,message,message2)
{
var i = start;
for(i=start;i<=end;i++){
var v = GetDisplayValue(prefix + i);
if(v != ""){
if(isEmailAddress(v) == false){
alert(message + i + message2);
return false;
}
}
}
return true;
}
function CheckEmptys(prefix,start,end)
{
var i = start;
var cnt = 0;
for(i=start;i<=end;i++){
var v = GetDisplayValue(prefix + i);
if(v != ""){
cnt++;
}
}
return cnt;
}
function LimitInputElementValue(ie)
{
var value = GetInputElementValue(ie);
var mlength = ie.getAttribute? parseInt(ie.getAttribute("maxlength")) : "";
if (ie.getAttribute && ie.value.length > mlength){
ie.value = ie.value.substring(0,mlength)
}
}
